<!DOCTYPE html>
<html>
    <head>
        <!-- <link rel="stylesheet" href="https://unpkg.com/leaflet@1.3.1/dist/leaflet.css" -->
        <!-- integrity="sha512-Rksm5RenBEKSKFjgI3a41vrjkw4EVPlJ3+OiI65vTjIdo9brlAacEuKOiQ5OFh7cOI1bkDwLqdLw3Zg0cRJAAQ==" -->
        <!-- crossorigin=""/><!--  --><!--  --><!--  --><!--  --><!--  -->
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">



        <!-- <script src="https://unpkg.com/leaflet@1.3.1/dist/leaflet.js" -->
        <!-- integrity="sha512-/Nsx9X4HebavoBvEBuyp3I7od5tA0UzAxs+j83KgC8PU0kgB4XiK4Lfe4y4cgBtaRJQEIFCW+oC506aPT2L1zw==" -->
        <!-- crossorigin=""></script> -->

        <style>
         body {
             padding: 0;
             margin: 0;
         }

         html, body, #map {
             height: 800pt;
             font: 10pt "Helvetica Neue", Arial, Helvetica, sans-serif;
         }

         .lorem {
             font-style: italic;
             text-align: justify;
             color: #AAA;
         }
        </style>
    </head>
    <body>
        <div id="sidebar-left" class="leaflet-sidebar collapsed">
            <!-- Nav tabs -->
            <div class="leaflet-sidebar-tabs">
                <ul role="tablist">
                    <li><a href="#lefthome" role="tab"><i class="fa fa-bars active"></i></a></li>
                    <li><a href="#lefttutorial" role="tab"><i class="fa fa-graduation-cap"></i></a></li>
                    <li><a href="#leftdocumentation" role="tab"><i class="fa fa-book"></i></a></li>
                    <li><a href="#leftaboutus" role="tab"><i class="fa fa-user"></i></a></li>
                    <li><a href="#leftlicence" role="tab"><i class="fa fa-gavel"></i></a></li>
                </ul>
                <!-- Link to gitlab of project -->
                <ul role="tablist">
                    <li><a href="https://gitlab.com/asludds/civicrm-turfcutter"><i class="fa fa-github"></i></a></li>
                </ul>
            </div>

            <!-- Tab panes -->
            <div class="leaflet-sidebar-content">
                <div class="leaflet-sidebar-pane" id="lefthome">
                    <!-- Content of left home goes here -->
                    <h1 class="leaflet-sidebar-header">
                        home
                        <span class="leaflet-sidebar-close"><i class="fa fa-caret-left"></i></span>
                    </h1>
                    <h1 class="lorem"><center>CiviCRM Turfcutter</center></h1>
                    <h4>What is a turfcutter?</h4>
                    <p>A turfcutter is an application which allows for political campaigns to assign volunteers (canvassers) to voters for canvassing.</p>
                    <h4>How do I use this turfcutter?</h4>
                    <p>There is a tutorial located below (check the graduation cap)</p>
                    <h4>Who made this turfcutter?</h4>
                    <p>Check the about-us tab below (the person shaped icon).</p>
                    <h4> How can I contribute to this project? </h4>
                    <p>Click the github icon below</p>
                    <h4> What type of licence does this software use?</h4>
                    <p> This software uses a INSERT LICENCE HERE. For more information, click the gavel icon below </p>
                </div>
                <div class="leaflet-sidebar-pane" id="lefttutorial">
                    <!-- Content of left tutorial goes here -->
                    <h1 class="leaflet-sidebar-header">
                        tutorial
                        <span class="leaflet-sidebar-close"><i class="fa fa-caret-left"></i></span>
                    </h1>
                    <p class="lorem">Content of left tutorial goes here</p>
                </div>
                <div class="leaflet-sidebar-pane" id="leftdocumentation">
                    <!-- Content of left documentation goes here -->
                    <h1 class="leaflet-sidebar-header">
                        documentation
                        <span class="leaflet-sidebar-close"><i class="fa fa-caret-left"></i></span>
                    </h1>
                    <p class="lorem">Content of documentation goes here</p>
                </div>
                <div class="leaflet-sidebar-pane" id="leftaboutus">
                    <!-- Content of left about us goes here -->
                    <h1 class="leaflet-sidebar-header">
                        about-us
                        <span class="leaflet-sidebar-close"><i class="fa fa-caret-left"></i></span>
                    </h1>
                    <p class="lorem">Content of left about us goes here</p>
                </div>
                <div class="leaflet-sidebar-pane" id="leftlicence">
                    <!-- Content of left licence goes here -->
                    <h1 class="leaflet-sidebar-header">
                        licence
                        <span class="leaflet-sidebar-close"><i class="fa fa-caret-left"></i></span>
                    </h1>
                    <p class="lorem">Content of left licence goes here</p>
                </div>
            </div>
        </div>

        <div id="sidebar-right" class="leaflet-sidebar collapsed">
            <div class="leaflet-sidebar-tabs">
                <ul role="tablist">
                    <li><a href="#righthome" role="tab"><i class="fa fa-bars active"></i></a></li>
                    <li><a href="#rightprofile" role="tab"><i class="fa fa-user"></i></a></li>
                </ul>
            </div>
            <!-- Tab panes -->
            <div class="leaflet-sidebar-content">
                <div class="leaflet-sidebar-pane" id="righthome">
                    <!-- Content of the right home -->
                    <h1 class="leaflet-sidebar-header">
                        righthome
                        <span class="leaflet-sidebar-close"><i class="fa fa-caret-right"></i></span>
                    </h1>
                    <h4 class="lorem"><center>Heat Map</center></h4>
                    <p>This tab allows for you to configure the heat map options of the turfcutter. This allows for you to make statistical queries on your voter data.</p>
                    <div class="slidecontainer">
                        <p>Show people who have not been contacted in last x days</p>
                        <input type="range" min="1" max="100" value="50" class="slider" id="people_not_contacted_in_last_x_days_slider" onchange="change()">
                        <span id=""></span>
                    </div>
                    <p>Show voters who have x language</p>
                    <div id="language_list"></div>
                    <script>generate_language_options()</script>
                    <button id="submit_heatmap_button" class="button submit_heatmap_button" type="button" onclick="submit_button_onClick()">Update heat map layer</button>


                </div>
                <div class="leaflet-sidebar-pane" id="rightprofile">
                    <!-- Content of the right profile -->
                    <h1 class="leaflet-sidebar-header">
                        Volunteer Information
                        <span class="leaflet-sidebar-close"><i class="fa fa-caret-right"></i></span>
                    </h1>
                    <p class="lorem">Here are a list of volunteers and their status for turf assignment</p>
                    <nav>
                        <ul id="volunteer_info_volunteer_list" class="volunteer_info_volunteer_list">
                        </ul>
                        <script>populate_volunteer_list()</script>
                    </nav>
                </div>
            </div>

        </div>







        <div id="map"></div>
        <script>
         /* var voters = get_voter_markers_from_civi() */
         /* var volunteers = get_volunteer_markers_from_civi(); */

         var northend = L.marker([42.3650, -71.0555]).bindPopup('This is the Northend.');
         var mit = L.marker([42.3591, -71.0931]).bindPopup('This is MIT');
         var central = L.marker([42.3655, -71.1040]).bindPopup('This is Central Square');
         var harvard = L.marker([42.3735, -71.1186]).bindPopup('This is Harvard Square');
         var voters = L.layerGroup([northend,mit,central,harvard]);

         var volunteers = L.layerGroup([]);
         var heatmap = L.layerGroup([]);

         var openStreetMaps = L.tileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
             maxZoom: 18,
             attribution: 'Map data &copy; OpenStreetMap contributors'
         });

         var googleStreets = L.tileLayer('http://{s}.google.com/vt/lyrs=m&x={x}&y={y}&z={z}',{
             maxZoom: 20,
             subdomains:['mt0','mt1','mt2','mt3']
         });

         var googleHybrid = L.tileLayer('http://{s}.google.com/vt/lyrs=s,h&x={x}&y={y}&z={z}',{
             maxZoom: 20,
             subdomains:['mt0','mt1','mt2','mt3']
         });

         var googleSat = L.tileLayer('http://{s}.google.com/vt/lyrs=s&x={x}&y={y}&z={z}',{
             maxZoom: 20,
             subdomains:['mt0','mt1','mt2','mt3']
         });

         var googleTerrain = L.tileLayer('http://{s}.google.com/vt/lyrs=p&x={x}&y={y}&z={z}',{
             maxZoom: 20,
             subdomains:['mt0','mt1','mt2','mt3']
         });

         var arcGis = L.tileLayer('http://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}', {
             maxZoom: 20,
			       attribution: 'Tiles &copy; Esri &mdash; Source: Esri, i-cubed, USDA, USGS, AEX, GeoEye, Getmapping, Aerogrid, IGN, IGP, UPR-EGP, and the GIS User Community'
		     });

         var map = L.map('map', {
             center: [42.3601, -71.0942],
             zoom: 14,
             layers: [voters, googleStreets]
         });

         var baseMaps = {
             "Google Street map": googleStreets,
             "Open Street Maps": openStreetMaps,
             "Google Hybrid Map": googleHybrid,
             "Google Satellite Map": googleSat,
             "Google Terrain Map": googleTerrain,
             "ArcGis": arcGis
         };

         var overlayMaps = {
             "Voter View": voters,
             "Volunteer View": volunteers,
             "Heat Map": heatmap
         };

         map.addControl(new L.Control.Scale());

         /*
            Adding custom buttons to leaflet control layer menu
            This is done by extending the leaflet control layer
          */
         leafletControlCustom();

         var control = new L.Control.Custom(baseMaps,overlayMaps).addTo(map);
         /* L.control.layers(baseMaps, overlayMaps).addTo(map); */


         var drawnItems = new L.FeatureGroup();
         var options = {
             position: 'topleft',
             editable : true,
             draw: {
                 polyline: false,
                 polygon: {
                     allowIntersection: false, // Restricts shapes to simple polygons
                     drawError: {
                         color: '#f4355f', // Color the shape will turn when intersects
                         message: '<strong>Oh snap!<strong> you can\'t draw that!' // Message that will show when intersect
                     },
                     shapeOptions: {
                         color: '#f4355f'
                     }
                 },
                 circle: true, // Turns off this drawing tool
                 rectangle: {
                     shapeOptions: {
                         clickable: false
                     }
                 },
                 circlemarker : false,
             },
             edit: {
                 featureGroup: drawnItems
             }
         };
         map.addLayer(drawnItems);

         var drawControl = new L.Control.Draw(options);
         map.addControl(drawControl);

         drawControlEdit = new L.Control.Draw(options);

         map.on('draw:created', function(e) {
             var type = e.layerType,
                 layer = e.layer;
             drawnItems.addLayer(layer);
         });

         map.on('draw:deleted', function (e) {
             /* drawControlEdit.remove(); */
             /* drawControl.addTo(map); */
         });

         map.on(L.Draw.Event.CREATED, function (e) {
             var type = e.layerType,
                 layer = e.layer;


             if (type === 'marker') {
                 var latlng = layer._latlng;
                 popupcontentMarker = get_popupcontentMarker(latlng);
                 var newlayer = L.marker([latlng.lat, latlng.lng]).bindPopup(popupcontentMarker, {
                     keepInView: true,
                     closeButton: false
                 });
                 voters.addLayer(newlayer);
                 newlayer.openPopup();
             }
             if (type === "polygon"){
                 var latlng = layer.getBounds().getCenter();
                 cornerLatLngs = layer.getLatLngs();
                 cornersOfPolygon = [[]];
                 for (var i = 0; i < cornerLatLngs[0].length; i++ ){
                     cornersOfPolygon[0].push([cornerLatLngs[0][i].lat,cornerLatLngs[0][i].lng]);
                 }
                 cornersOfPolygon[0].push({name: 'poly2'});
                 var turfPolygon = turf.polygon(cornersOfPolygon);
                 var pointsWithin = voters.getLayers();
                 formattedPointsWithin = [];
                 for (var i = 0; i < pointsWithin.length; i++){
                     formattedPointsWithin.push([pointsWithin[i]._latlng.lat,pointsWithin[i]._latlng.lng]);
                 }
                 formattedTurfPoints = turf.points(formattedPointsWithin);
                 var pointsWithinPolygon = turf.pointsWithinPolygon(formattedTurfPoints,turfPolygon);
                 window.pointsWithinPolygon = pointsWithinPolygon;
                 var popupcontentPolygon = get_popupcontentPolygon(latlng,cornersOfPolygon,pointsWithinPolygon);
                 var newlayer = L.popup().setLatLng([latlng.lat,latlng.lng]).bindPopup(popupcontentPolygon, {
                     keepInView: false,
                     closeButton: true
                 });
                 voters.addLayer(newlayer);
                 newlayer.openPopup();
                 /* voters.addLayer(layer); */
             }

             if(type == "rectangle"){
                 var centerlatlng = layer.getBounds().getCenter();
                 popupcontentRectangle = get_popupcontentRectangle(centerlatlng);
                 var newlayer = L.popup().setLatLng([centerlatlng.lat,centerlatlng.lng]).bindPopup(popupcontentRectangle, {
                     keepInView: true,
                     closeButton: true
                 });
                 voters.addLayer(newlayer);
                 newlayer.openPopup();
                 voters.addLayer(layer);
             }
             if(type == 'circle'){
                 var centerlatlng = layer._latlng;
                 popupcontentCircle = get_popupcontentCircle(centerlatlng);
                 var newlayer = L.popup().setLatLng([centerlatlng.lat,centerlatlng.lng]).bindPopup(popupcontentCircle, {
                     keepInView: true,
                     closeButton: true
                 });
                 voters.addLayer(newlayer);
                 newlayer.openPopup();
                 voters.addLayer(layer);
             }
         });


         var leftsidebar = L.control.sidebar({ container: 'sidebar-left', position : 'left' })
                            .addTo(map)
                            .open('lefthome');

         var rightsidebar = L.control.sidebar({ container: 'sidebar-right', position : 'right' })
                             .addTo(map);


        </script>
    </body>

</html>
